<?php

namespace App\HttpController\History;

use App\HttpController\Base\Base;
use App\Key\K;
use App\Model\History\ServerInfo;
use App\Model\History\ServerList;
use App\Model\History\SubscribeList;
use App\Tools\Proxy;
use App\Tools\System;
use EasySwoole\ORM\DbManager;
use Swoole\Coroutine;

class Notice extends Base
{
    public function index()
    {
        $model = new ServerList();
        switch ($this->request()->getMethod()) {
            case 'POST':
                $data = $this->getRequestData();
                break;
        }
    }
    //在正常的运行过程中,子服务器也会上传数据
    public function run(){
        $model=new ServerInfo();
        switch ($this->request()->getMethod()){
            case 'POST':
                $data=$this->getRequestData();
                if (!$data['server_id']) {
                    System::log('no server_id key post');
                    return $this->jsonSuccess('no server post');
                }
                $data['info']=json_decode($data['info'],true);
                if (!$data['info']) {
                    System::log('no server info post');
                    return $this->jsonSuccess('no server info');
                }
                try {
                    $has=$model->where(['server_id'=>$data['server_id']])->get();
                    if ($has){
                        $model->where(['server_id'=>$data['server_id']])->update(['info'=>$data['info']]);
                    }else{
                        $server=$model::create($data);
                        $server->save();
                    }
                }catch (\Throwable $throwable){
                    System::log('notice info error ,msg:'.$throwable->getMessage());
                }
                return  $this->jsonSuccess(['success']);
                break;
        }
    }
    //在正常的代理 开启过程中，子服务器也会上传代理的信息，从而判断是不是重复使用代理

    public function proxy(){
        $model=new ServerList();
        switch ($this->request()->getMethod()){
            case 'POST':
                $data=$this->getRequestData();
                if (!$data[K::PROXY_SERVER_DB_ID]) return $this->jsonSuccess(['code'=>200]);
                $model->where(['key'=>$data[K::KEY_PROXY_CURRENT]])->update(['update_time'=>time()]);
                if (!$data['proxy']['ip']) return  $this->jsonSuccess(['code'=>200]);
                $used=$model->where(['ip'=>$data['proxy']['ip']])->field(['server_id'])->all();
                $used=array_map(function ($v){
                    return $v['server_id'];
                },$used);
                $used=array_unique($used);
                if (!$used||(count($used)===1&&in_array($data['server']['server_id'],$used))) return $this->jsonSuccess(['code'=>200]);
                return $this->jsonSuccess(['code'=>404,'used'=>$used]);
                break;
        }
    }

    //在服务器运行过程中代理 被封，会提交到这个接口来
    public function forbidden()
    {
        $model = new ServerList();
        switch ($this->request()->getMethod()) {
            case 'POST':
                $data = $this->getRequestData();
                //要根据IP和 key来更新数据
                $model->where(['key' => $data['proxy']['key']])->update(['status' => ServerList::SERVER_STATUS_FORBIDDEN, 'forbidden_time' => time(), 'forbidden_server_id' => $data['server']['server_id']]);
                $model->where(['ip' => $data['proxy']['ip']])->update(['status' => ServerList::SERVER_STATUS_FORBIDDEN, 'forbidden_time' => time(), 'forbidden_server_id' => $data['server']['server_id']]);
                return $this->jsonSuccess(['success']);
                break;
        }
    }
}
